%DP specific instructions

%%% Aleph Parameters---------------------------------
:- set(clauselength,5).
:- set(evalfn,user). 
:- set(minpos,100).
:- set(noise,100).
:- set(m,100).
%:- set(minacc,1).
%:- set(minscore,0.1).


%%% Train and Test Sets---------------------------------
:- set(record,true).
:- set(recordfile,'B100.trace').
:- set(train_pos, '../DPdata/trains1B1000.f').
:- set(train_neg, '../DPdata/trains1B1000.n').

%load alternate examples in different module, so they don't get mixed up
:- [alt_train_pos:'../DPdata/trains2B1000.f'].
:- [alt_train_neg:'../DPdata/trains2B1000.n'].

%%% Background Knowledge---------------------------------
:- consult('../DPdata/trains1B1000.bk').
:- consult('../DPdata/trains2B1000.bk').


%%% Alternate Cost Function---------------------------------
%get the clause coverage on alternate pos and neg
apply_rule_on_alternate(Clause, AP, AN) :-
        Clause = (H :- B), %specify clause shape
%       writeln(doing:Clause),get0(_), %get is waiting for a character input
        %get matches list
        findall( H, (alt_train_pos : H, \+ alt_deleted(H), once(B)), List_AP),
        length(List_AP, AP), %get the length of the list
        findall( H, (alt_train_neg : H, once(B)), List_AN),
        length(List_AN, AN).

%%% Cost function
cost(Clause, [P, N, L], Cost) :-
	evalfn(mestimate, [P,N,L], Acc1),
	Cost is -P * Acc1.
