# usage: perl progol2aleph.pl train1.pl trains
# where train1.pl is generated by prolog examples('train1.pl')?
# it outputs trains.bk, trains.f, trains.n files for aleph

use strict;
use warnings;
use Carp;

my $class = "east"; #the class to look for

#Process input and create files
confess "Call should be: perl ", __FILE__, " prolog_file aleph_file. Stopped"
    unless @ARGV == 2;
open(INPUT, $ARGV[0]) ||
    confess "couldn't open ", $ARGV[0], ": $!. Stopped"; 
my $bk = $ARGV[1].".bk";
my $n = $ARGV[1].".n";
my $f = $ARGV[1].".f";
open(OUTPUTBK, '>', $bk) ||
    confess "couldn't open ", $bk, ": $!. Stopped";
open(OUTPUTN, '>', $n) ||
    confess "couldn't open ", $n, ": $!. Stopped";
open(OUTPUTF, '>', $f) ||
    confess "couldn't open ", $f, ": $!. Stopped";


#read input file
while (my $line = <INPUT>){
    if ($line =~ /^$class/){
	print OUTPUTF $line;
    }
    elsif ($line =~ /^:- $class/){
	$line =~ s/:- //;
	print OUTPUTN $line;
    }
    else {
	print OUTPUTBK $line;
    }
}

