%%%%%%%%%%%%%%%%%%%%%%%
% Train problem. This involves 5 eastbound trains and
%	5 westbound trains. Learns simple rule which distinguishes
%	between eastbound and westbound trains.
%%%%%%%%%%%%%%%%%%%%%%%

%%% Aleph Parameters---------------------------------



%%% Mode Declarations ---------------------------------
:- modeh(1,east(+train)).

:- modeb(*,infront(+train,-car,-car)).
:-determination(east/1,infront/3).
:- modeb(*,has_car(+train,-car)).
:-determination(east/1,has_car/2).
:- modeb(1,long(+car)).
:-determination(east/1,long/1).
:- modeb(1,closed(+car)).
:-determination(east/1,closed/1).
:- modeb(1,short(+car)).
:-determination(east/1,short/1).
:- modeb(1,open(+car)).
:-determination(east/1,open/1).
:- modeb(1,double(+car)).
:-determination(east/1,double/1).
:- modeb(1,jagged(+car)).
:-determination(east/1,jagged/1).
:- modeb(1,load(+car,#shape,#int)).
:-determination(east/1,load/3).
:- modeb(1,wheels(+car,#int)).
:-determination(east/1,wheels/2).

%%% Additional predicates ---------------------------------
shape(circle).  shape(ellipse).  shape(hexagon).  shape(rectangle).
shape(triangle).  shape(utriangle).  shape(u_shaped). shape(diamond).


%%% Background Knowledge---------------------------------
:- consult('trains1B1000.bk').
