#!/usr/bin/perl

# Usage: perl generateNoise.pl ../trains1 5 1000
# Usage: perl generateNoise.pl file_name_stem percentage totRecordNb

use strict;
use warnings;
use Carp;

my $file = $ARGV[0]; #the stem file name
my $percentage = $ARGV[1];
my $totNb = $ARGV[2];
confess "Percentage should be between 0 and 100. Stopped"
    unless $percentage >= 0 && $percentage <= 100;

#select lines to flip
my %toFlip;
foreach my $i (1 .. $totNb){
    $toFlip{$i} = $i if (rand(100) <= $percentage);
}

open(OUTPUTF, '>', $file."_n.f") ||
    confess "couldn't open a file: $!. Stopped";
open(OUTPUTN, '>', $file."_n.n") ||
    confess "couldn't open a file: $!. Stopped";

my @ex = ("f", "n");

#for each instance file
foreach my $i (0, 1){
    open(INPUT, "$file.".$ex[$i]) ||
	confess "couldn't open a file: $!. Stopped";
    my $lineNb = 1;
    while (my $line = <INPUT>){
	no strict;
	my $fh;
	($toFlip{$lineNb}) ?
	    ($fh = "OUTPUT".uc($ex[($i+1)%2])) : 
	    ($fh = OUTPUT.uc($ex[$i])); 
	print $fh $line;
	
	$lineNb++;
    }
    close(INPUT);
}

close(OUTPUTF);
close(OUTPUTN);
