#!/bin/sh
########################################
# generate train files 
########################################

# assume we have generated theories, in theory1.pl and theory2.pl
# generate TOTINSTANCE trains
echo Generating trains for run $RUN

counter=0
for cohort in 1 2
  do
  TRAIN="$GENTRAIN$cohort" #current train  being generated
  cat theory"$cohort".pl > concept.pl

  #create empty files
  echo -n > "$TRAIN".f; echo -n > "$TRAIN".n; echo -n > "$TRAIN".bk
  fcount=0;ncount=0

  while [ $fcount -lt $TOTINSTANCE -o $ncount -lt $TOTINSTANCE ]
    do
    echo Doing cohort $cohort with $fcount and $ncount trains
    date
    #amend background.pl so to get different car numbers
    startNumberingAt=`expr $counter \* $TOTINSTANCE \* 10`
    perl "$SCRIPTS/"amendBackground.pl "$SCRIPTS/"background.tmpl "$THIS"/background.pl  $startNumberingAt
    
    progol -s 4000000000  <<EOF > progol.trace
    [drawtrain]?
    make(1000,train)?
    [train]?
    examples('generatedTrain.pl')?
    quit?
EOF
   
    perl progol2aleph.pl generatedTrain.pl temp
    cat temp.f >> "$TRAIN".f; cat temp.n >> "$TRAIN".n
    cat temp.bk >> "$TRAIN".bk

    #check if we have the required number. Repeat if not
    fcount=`awk 'END{print NR}' "$TRAIN".f` #get line counts
    ncount=`awk 'END{print NR}' "$TRAIN".n`
    counter=`expr $counter + 1`
  done

  #truncate the files to the required nb of examples
  head -n "$TOTINSTANCE" "$TRAIN".f > temp.f
  head -n "$TOTINSTANCE" "$TRAIN".n > temp.n
  cat temp.f > "$TRAIN".f; cat temp.n > "$TRAIN".n
  rm temp.*
done

