#!/usr/bin/perl

# Usage: perl scripts/selectTheories.pl generatedTheories.txt 5

use strict;
use warnings;
use Carp;

#Process input and create files
open(INPUT, $ARGV[0]) ||
    confess "couldn't open ", $ARGV[0], ": $!. Stopped"; 
my $range = $ARGV[1];
open(OUTPUT1, ">theory1.pl") ||
    confess "couldn't open a file: $!. Stopped"; 
open(OUTPUT2, ">theory2.pl") ||
    confess "couldn't open a file: $!. Stopped"; 

#slurp input in one line
my $holdTerminator = $/;
undef $/;
my $theories = <INPUT>;
$/ = $holdTerminator;

#get the 3 sets, one rule per line
my @sets = split /\%+\s*THEORY\s+\d\s*/, $theories;
foreach (@sets){
    s/\n//g;
    s/\./\.\n/g;
}

#let set1 be DP1, set2 DP2, and set3 the common
for (my $i = 3; $i > 0; $i--){
    my $r = int(rand($range));
    my @clauses = split /\n/, $sets[$i];
    my $copy = "";
    $copy .= "$clauses[$_]\n" foreach(0..$r);
    #print "theory $i\n$copy\n";
    
    print OUTPUT1 "%% Different:\n", $copy if $i == 1;
    print OUTPUT2 "%% Different:\n", $copy if $i == 2;
    if ($i == 3){
	print OUTPUT1 "%% Common:\n", $copy;
	print OUTPUT2 "%% Common:\n", $copy;
    }
}

